#define MACRO1 1
#define MACRO2 2
#define MACRO3 3
#define MACRO4 4
#define B_DIFF 0

#define MACRO1_STRING "macro1"
#define MACRO2_STRING "macro2"
#define MACRO3_STRING "macro3"
#define MACRO4_STRING "macro4"


#define rowsSet  10    // sets the number of rows in the matrix
#define columnsSet  12 // sets the number of columns in the matrix
//
// Load the normal key matrix with the Teensyduino key names described at www.pjrc.com/teensy/td_keyboard.html
// A zero indicates no normal key at that location.

uint16_t normal[rowsSet][columnsSet] = {
  {KEY_HOME,KEY_PAGE_UP,KEY_F1,KEY_F2,KEY_F3,KEY_F4,KEY_F5,KEY_F6,KEY_F7,KEY_F8,KEY_F9,KEY_F10},
  {KEY_END,KEY_PAGE_DOWN,KEY_F11,KEY_F12,KEY_F13,KEY_F14,KEY_F15,KEY_F16,KEY_F17,KEY_F18,KEY_F19,KEY_F20},
  {0,KEY_UP,KEY_ENTER,KEY_7,KEY_8,KEY_9,KEY_0,KEY_LEFT_BRACE,KEY_RIGHT_BRACE,KEY_BACKSLASH,KEY_MINUS,KEY_EQUAL},
  {KEY_ESC,0,KEY_ENTER,KEY_4,KEY_5,KEY_6,KEY_0,KEYPAD_PLUS,KEYPAD_MINUS,KEY_INSERT,0,0},
  {KEY_LEFT,KEY_DOWN,KEY_RIGHT,KEY_1,KEY_2,KEY_3,KEYPAD_PERIOD,KEYPAD_ASTERIX,KEYPAD_SLASH,KEY_DELETE,0,0},
  {KEY_TILDE,KEY_1,KEY_2,KEY_3,KEY_4,KEY_5,KEY_6,KEY_7,KEY_8,KEY_9,KEY_0,KEY_END},
  {KEY_TAB,KEY_Q,KEY_W,KEY_E,KEY_R,KEY_T,KEY_Y,KEY_U,KEY_I,KEY_O,KEY_P,KEY_BACKSPACE},
  {KEY_CAPS_LOCK,KEY_A,KEY_S,KEY_D,KEY_F,KEY_G,KEY_H,KEY_J,KEY_K,KEY_L,KEY_BACKSPACE,KEY_ENTER},
  {0,KEY_Z,KEY_X,KEY_C,KEY_V,KEY_B,KEY_N,KEY_M,KEY_COMMA,KEY_PERIOD,0,0},
  {0,0,0,0,KEY_SPACE,KEY_SPACE,KEY_SPACE,KEY_SPACE,KEY_SLASH,0,0,0},
 
                                 
 
};
// Load the modifier key matrix with key names at the correct row-column location.
// A zero indicates no modifier key at that location.
uint16_t modifier[rowsSet][columnsSet] = {
 {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {MODIFIERKEY_SHIFT,0,0,0,0,0,0,0,0,0,MODIFIERKEY_SHIFT,0},
  {MODIFIERKEY_CTRL,MODIFIERKEY_ALT,MODIFIERKEY_GUI,0,0,0,0,0,0,0,0,0},
};
// Load the media key matrix with Fn key names at the correct row-column location.
// A zero indicates no media key at that location.
uint16_t mediaMacro[rowsSet][columnsSet] = {
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,MACRO1,MACRO2},
  {0,0,0,0,0,0,0,0,0,0,MACRO3,MACRO4},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
};
// Initialize the saveState matrix with one's.
// 1 = key not pressed, 0 = key is pressed
bool saveState[rowsSet][columnsSet] = {
  {1, 1, 1, 1, 1, 1, 1, 1, 1,1,1,1},
  {1, 1, 1, 1, 1, 1, 1, 1, 1,1,1,1}, 
  {1, 1, 1, 1, 1, 1, 1, 1, 1,1,1,1}, 
  {1, 1, 1, 1, 1, 1, 1, 1, 1,1,1,1}, 
  {1, 1, 1, 1, 1, 1, 1, 1, 1,1,1,1}, 
  {1, 1, 1, 1, 1, 1, 1, 1, 1,1,1,1}, 
  {1, 1, 1, 1, 1, 1, 1, 1, 1,1,1,1}, 
  {1, 1, 1, 1, 1, 1, 1, 1, 1,1,1,1}, 
  {1, 1, 1, 1, 1, 1, 1, 1, 1,1,1,1}, 
  {1, 1, 1, 1, 1, 1, 1, 1, 1,1,1,1}, 
 
 
};

uint32_t bounceTimer[rowsSet][columnsSet] = {
 {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
  {0,0,0,0,0,0,0,0,0,0,0,0},
};


//
// Define the Teensy 4.0 I/O numbers (translated from the FPC pin #)
uint16_t rowIn[rowsSet] = {14, 15, 16, 17, 18, 19, 20, 21, 22, 23}; // Teensy 4.0 I/O numbers for rows
//
uint16_t colOut[columnsSet] = {2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13}; // Teensy 4.0 I/O numbers for columns

// Declare variables that will be used by functions
bool keyFull = false; // Goes high when slots 1 through 6 contain normal keys

// slot 1 through slot 6 hold the normal key values to be sent over USB.
// value of 0 means the slot is empty and can be used.
uint16_t numKey[6] = {0, 0, 0, 0, 0, 0};

// These variables are sent over USB as modifier keys.
uint16_t numModif[8] = {0, 0, 0, 0, 0, 0, 0, 0};

// Function to load the key name into the first available slot
void LoadKey(uint16_t key)   
{
  for (size_t i = 0; i < 6; i++)
  {
    if (!numKey[i])
    {
      numKey[i] = key;
      break;
    }
  }
  keyFull = true;
  for (size_t i = 0; i < 6; i++)
  {
    if (!numKey[i])
    {
      keyFull = false;
      break;
    }
  }
}
//
// Function to clear the slot that contains the key name
void UnloadKey(uint16_t key)
{
  for (size_t i = 0; i < 6; i++)
  {
    if (numKey[i] == key)
    {
      numKey[i] = 0;
    }
  }
  keyFull = true;
  for (size_t i = 0; i < 6; i++)
  {
    if (!numKey[i])
    {
      keyFull = false;
      break;
    }
  }
}
//
// Function to load the modifier key name into the appropriate mod variable
void LoadModif(uint16_t modKey)
{
  for (size_t i = 0; i < 8; i++)
  {
    if (!numModif[i])
    {
      numModif[i] = modKey;
      break;
    }
  }
}
//
// Function to load 0 into the appropriate mod variable
void UnloadModif(uint16_t modKey)
{
  for (size_t i = 0; i < 8; i++)
  {
    if (numModif[i] == modKey)
    {
      numModif[i] = 0;
    }
  }
}
//
// Function to send the modifier keys over usb
void SendModif()
{
  uint16_t modifier = 0;
  for (size_t i = 0; i < 8; i++)
  {
    modifier |= numModif[i];
  }
  Keyboard.set_modifier(modifier);
  Keyboard.send_now();
}
//
// Function to send the normal keys in the 6 slots over usb
void SendKey()
{
  Keyboard.set_key1(numKey[0]);
  Keyboard.set_key2(numKey[1]);
  Keyboard.set_key3(numKey[2]);
  Keyboard.set_key4(numKey[3]);
  Keyboard.set_key5(numKey[4]);
  Keyboard.set_key6(numKey[5]);
  Keyboard.send_now();
}

//----------------------------------Setup-------------------------------------------
void setup()
{
  for (size_t i = 0; i < columnsSet; i++)
  { // loop through all column pins
    pinMode(colOut[i], OUTPUT); // set each column pin as an output
    digitalWrite(colOut[i], LOW);
  }

  for (size_t i = 0; i < rowsSet; i++)
  { // loop through all row pins
    pinMode(rowIn[i], INPUT_PULLDOWN); // set each column pin as an input with pulldown resistor
  }
}
//
extern volatile uint8_t keyboard_leds; // 8 bits sent from Host to Teensy that give keyboard LED status. Caps lock is bit D1.
//
//---------------------------------Main Loop---------------------------------------------
//
void loop()
{

  // Scan keyboard matrix with an outer loop that drives each column high and an inner loop that reads every row (without pull ups).
  // The routine looks at each key's present state (by reading the row input pin) and also the previous state from the last scan
  // that was 30msec ago. The status of a key that was just pressed or just released is sent over USB and the state is saved in the saveState matrix.
  // The keyboard keys will read as logic high if they are pressed (positive logic).
  // The saveState matrix uses negative logic (low=pressed).
  //

  for (size_t y = 0; y < columnsSet; y++)
  { // loop through the rows
    
    digitalWrite(colOut[y], HIGH); // Activate Row (send it high)
    delayMicroseconds(300);       // give the row time to go low and settle out
    for (size_t x = 0; x < rowsSet; x++)
    { // loop through the columns
      bool digInp = digitalRead(rowIn[x]);
      if (digInp && saveState[x][y] && millis() - bounceTimer[x][y] > B_DIFF)
      {
        bounceTimer[x][y] = millis();
        saveState[x][y] = false; // Save state of key as "pressed"
        if (modifier[x][y])
        {
          LoadModif(modifier[x][y]);
          SendModif();
        }
        else if (normal[x][y])
        {
          if (keyFull)
          {
            saveState[x][y] = true; // Ruturn state of key as "not pressed"
          }
          else
          {
            LoadKey(normal[x][y]); // update first available slot with normal key name
            SendKey();             // send all slots over USB including the key that just got pressed
          }
        }
        else if (mediaMacro[x][y])
        {
          if (mediaMacro[x][y] == KEY_MEDIA_MUTE)
          {
            Keyboard.press(mediaMacro[x][y]);   // media key is sent using keyboard press function per PJRC
            delayMicroseconds(3000);        // delay time before releasing to make sure it gets sent over USB
            Keyboard.release(mediaMacro[x][y]); // send mediaMacro key release
          }
          else if (mediaMacro[x][y] == 1)
          {
            Keyboard.print(MACRO1_STRING); // macros key is sent using keyboard print function per PJRC
          }
          else if (mediaMacro[x][y] == 2)
          {
            Keyboard.print(MACRO2_STRING); // macros key is sent using keyboard print function per PJRC
          }
          else if (mediaMacro[x][y] == 3)
          {
            Keyboard.print(MACRO3_STRING); // macros key is sent using keyboard print function per PJRC
          }
           else if (mediaMacro[x][y] == 4)
          {
            Keyboard.print(MACRO4_STRING); // macros key is sent using keyboard print function per PJRC
          }
        
        }
      }
      else if (!digInp && !saveState[x][y] && millis() - bounceTimer[x][y] > B_DIFF)
      {
        bounceTimer[x][y] = millis();
        saveState[x][y] = true; // Save state of key as "not pressed"
        if (modifier[x][y])
        {
          UnloadModif(modifier[x][y]); // function reads which modifier key was released and loads 0 into the appropriate variable
          SendModif();
        }
        else if (normal[x][y])
        {
          UnloadKey(normal[x][y]); // clear the slot that contains the normal key name
          SendKey();               // send all slots over USB including the key that was just released
        }
      }
    }
    digitalWrite(colOut[y], LOW);
  }
  //delay(20);
}
